Data Center (CodeForces - 1250F )(思路)

30 篇文章 0 订阅

You are developing a project to build a new data center. The data center will be a rectangle with an area of exactly nn square meters. Each side of the data center must be an integer.

Your goal is to minimize the impact of the external environment on the data center. For this reason, you want to minimize the length of the perimeter of the data center (that is, the sum of the lengths of its four sides).

What is the minimum perimeter of a rectangular data center with an area of exactly nn square meters, if the lengths of all its sides must be integers?

Input

The first and only line of the input contains an integer nn (1≤n≤1051≤n≤105), where nn is the area of the data center in square meters.

Output

Print the required minimum perimeter in meters.

Examples

Input

36

Output

24

Input

13

Output

28

Input

1

Output

4

Note

In the first example, the required shape of the data center is 6×66×6 square. Its area is 3636 and the perimeter is 6+6+6+6=246+6+6+6=24.

In the second example, the required shape of the data center is 1×131×13 rectangle. Its area is 1313 and the perimeter is 1+13+1+13=281+13+1+13=28.

In the third example, the required shape of the data center is 1×11×1 square. Its area is 11 and the perimeter is 1+1+1+1=41+1+1+1=4.

题意:这道题意思就是给你一个长方形的面积,让你求出长方形周长的最小值。

思路:一开始,刚看到这道题的我,想着这应该是一个规律题,于是我就在纸上推了好长时间的规律,什么质数的情况下,周长应该怎么算;什么面积的平方根刚好是整数什么什么的。后来推着推着我突然发现,这不是用暴力直接就可以做吗,先设一个边为i,然后用for循环遍历i值,每次更新周长的值,直到找到那个最小的周长值。说到底还是思路不行QAQ

AC代码:

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <math.h>
const int maxx=0x3f3f3f3f;
using namespace std;
int main()
{
    int n;
    scanf("%d",&n);
    int cnt=maxx;
    for(int i=1;i*1<=n;i++)
    {
        if(n%i==0)
            {
                int ans=n/i;
                cnt=min(cnt,(ans+i)*2);
            }
    }
    printf("%d\n",cnt);
    return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值